



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java 27 - 3 反射之 通过反射获取构造方法并使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java 27 - 3 反射之 通过反射获取构造方法并使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 18:12:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>类 Constructor&lt;T&gt;：提供关于类的单个构造方法的信息以及对它的访问权限。</p>
<p>通过反射的方法获取构造方法并使用 &nbsp;ps：先忽略泛型</p>
<p>　　A.1：获取构造方法的数组：</p>
<p>　　　　public Constructor&lt;?&gt;[] getConstructors():获得所有公共构造方法</p>
<p>　　　　public Constructor&lt;?&gt;[] getDeclaredConstructors():获得所有构造方法</p>
<p>　　A.2：获取单个构造方法(用于非私有的构造方法)</p>
<p>　　　　public Constructor&lt;T&gt; getConstructor(Class&lt;?&gt;... parameterTypes)</p>
<p>　　　　　　参数表示的是：你要获取的构造方法的构造参数个数及数据类型的class字节码文件对象</p>
<p>　　A.3：获取单个构造方法（用于私有的构造方法）</p>
<p>　　　　public Constructor&lt;T&gt; getDeclaredtConstructor(Class&lt;?&gt;... parameterTypes)</p>
<p>　　B.1：初始化构造方法的实例：(用于非私有的构造方法)</p>
<p>　　　　public T newInstance(Object... initargs) &nbsp;注意：T表示的是泛型，Object... initargs表示的是你要实例化的指定参数</p>
<p>　　　　　　使用此 Constructor对象表示的构造方法来创建该构造方法的声明类的新实例，并用指定的初始化参数初始化该实例。</p>
<p>　　B.2：初始化构造方法的实例：(用于私有的构造方法)　　　</p>
<p>　　　先用：　public void <strong>setAccessible</strong>(boolean&nbsp;flag)：flag的值为 <tt>true</tt> 则指示反射的对象在使用时应该取消 Java 语言访问检查。</p>
<p>　　　再用：　public T newInstance(Object... initargs)</p>
<p>代码：</p>
<p>　　A：public Constructor&lt;?&gt;[] getConstructors():获得所有公共构造方法</p>
<div>
<pre class="prettyprint linenums">         Constructor[] c1 = c.getConstructors();<br />
         System.out.println(c1);// 返回的是地址值，证明得到的是个数组对象<br />
         // 遍历这个数组<br />
         for (Constructor ct : c1) {<br />
             System.out.println(ct);<br />
         }  //获得Person类中的所有公告构造方法</pre>
</div>
<p>　　B：public Constructor&lt;?&gt;[] getDeclaredConstructors():获得所有构造方法</p>
<div>
<pre class="prettyprint linenums">         // B：public Constructor&lt;?&gt;[] getDeclaredConstructors():获得所有构造方法<br />
          Constructor[] c1 = c.getDeclaredConstructors();<br />
          //遍历数组<br />
          for(Constructor ct : c1){<br />
              System.out.println(ct);<br />
          } //获得Person类的所有构造方法</pre>
</div>
<p>　　</p>
<p>　　C：public Constructor&lt;T&gt; getConstructor(Class&lt;?&gt;... parameterTypes)：获得指定的构造方法</p>
<p>获得无参构造方法：　</p>
<div>
<pre class="prettyprint linenums">         Constructor c1 = c.getDeclaredConstructor();<br />
         System.out.println(c1);</pre>
</div>
<p>获得带参构造方法：</p>
<div>
<pre class="prettyprint linenums">         //获取指定的构造方法，需要该方法的参数列表<br />
         Constructor c1 = c.getDeclaredConstructor(String.class,int.class,String.class);<br />
         System.out.println(c1);</pre>
</div>
<p>　　D：public T newInstance(Object... initargs) &nbsp;注意：T表示的是泛型，Object... initargs表示的是你要实例化的指定参数</p>
<p>　　　　使用此 Constructor对象表示的构造方法来创建该构造方法的声明类的新实例，并用指定的初始化参数初始化该实例。</p>
<p>　　　　也就是初始化对象</p>
<p>通过反射获取公共带参构造方法并使用：</p>
<div>
<pre class="prettyprint linenums">         //获取指定的构造方法，需要该方法的参数列表<br />
         Constructor c1 = c.getDeclaredConstructor(String.class,int.class,String.class);<br />
         System.out.println(c1);

         // 通过带参构造方法对象创建对象<br />
         // public T newInstance(Object... initargs):<br />
         //有泛型，前面没使用泛型，先用Objcet<br />
         Object b = c1.newInstance("张三",13,"家乡");<br />
         System.out.println(b); //Person [name=张三, age=13, address=家乡]</pre>
</div>
<p>通过反射获取私有带参构造方法并使用：</p>
<div>
<pre class="prettyprint linenums">         //获取指定的私有构造方法<br />
         Constructor c1 = c.getDeclaredConstructor(String.class);

         //public void setAccessible(boolean flag)：<br />
         //flag的值为 true 则指示反射的对象在使用时应该取消 Java 语言访问检查。<br />
         c1.setAccessible(true);

         //　public T newInstance(Object... initargs)<br />
         Object ob = c1.newInstance("张三");<br />
         System.out.println(ob);</pre>
</div>
<p>后两个代码，相当于以前的：　只不过通过反射，不需要导入对应的类</p>
<div>
<pre class="prettyprint linenums"> public Person(String name, int age, String address)

  Person p = new Person("张三",13,"家乡");<br />
  System.out.println(p);</pre>
</div>
<p>和</p>
<div>
<pre class="prettyprint linenums">  private Person(String name){}

  Person p = new Person("风清扬");<br />
  System.out.println(p);</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q25kwq7.html">谈谈一些有趣的CSS题目（四）-- 从倒影说起，谈谈 CSS 继承 inherit</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxk6m08.html">QT，静态变量要记得初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdd5p7q.html">在没有安装有mvc3的主机上部署asp&period;net mvc3网站，需要包含的DLL文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdoeoz8.html">jq菜单折叠效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1w0p29.html">设置text-overflow文本溢出隐藏时的对齐问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rwwgmq.html">Java Web之JSP技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gly24q.html">SURF算法与源码分析、上</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5ewjq.html">&lbrack;转&rsqb;&rsqb;将 ASP&period;NET MVC3 Razor 项目部署到虚拟主机中</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11vkv9.html">DZY Loves Chessboard</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yyvjnq.html">数据类型转换的三种方式 Convert&comma;parse和TryParse的解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkxevq.html">linux mysql开启远程链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj32dy9.html">hdu 2736 Surprising Strings（类似哈希，字符串处理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjy0zk9.html">Oracle函数题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m4zdgq.html">ROS Node&sol;Topic&sol;Message&sol;Service的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zoj0g9.html">在PHP中连接数据库时获取最后的一个ID</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp51z79.html">vue路由组件群</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1j3349.html">Shadow Properties之美（二）【Microsoft Entity Framework Core随笔】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjxxeq.html">Android RecyclerView预览item</a>
		</li>
						<li><a href="https://www.batexi.com/a/90re6nj9.html">fillder--客户端指定访问IP段</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyjmon9.html">027 ResourceBundle&period;getBundle方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49576wzq.html">读jQuery源码 - Callbacks</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv3g0x8.html">&lbrack;Android&rsqb;使用Gradle提交自己开源Android库到Maven中心库</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq46glj8.html">Android消息机制入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx4kld9.html">iOS开发之AFN的基本使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zlon3q.html">学习Coding-iOS开源项目日志（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gxelzq.html">php  图片上传 使用微秒做文件名</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxwgx8.html">C&num;复习⑤</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kdjzj9.html">android Gui系统之WMS&lpar;1&rpar;----window flags &amp;amp&semi; view flags</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zly5xq.html">IT软件开发常用英语词汇</a>
			</li>
						<li><a href="https://www.batexi.com/a/495n3p09.html">面试题整理&colon;C&num;（二）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
